from django.shortcuts import render
from django.http import HttpResponse
from django.http import HttpResponseRedirect
from django.template import RequestContext
from django.template.loader import render_to_string
from django.shortcuts import render_to_response

from utilities.IdleProductionAnalyzer import *
from replayparsing import Replay
import replayanalyzer

from django.conf import settings

def printAll(request,replayhash):
    if len('cd2061ff6d809f719f9d4c410a3ffa1c') == len(replayhash):
        for ch in replayhash:
            if not ch.isalnum():
                return HttpResponse("wait ... what?" + replayhash)
    else:
        return HttpResponse("wait ... what?" + replayhash)

    replay = Replay(os.path.join(settings.REPLAY_UPLOAD_FOLDER, str(request.user.id), replayhash + '.SC2Replay'))
    everything = ""
    everything += "Number of tracker events: " + str(len(replay.trackerEvents)) + "<br>"

    import pprint

    everything += "Frames: " + str(replay.frames) + " "

    everything += "Tracker events: <br>"
    for event in replay.trackerEvents:
        everything += "<br>" + str(event) + "<br>"

    everything += "All info:" + str(replay.allInfo)
    everything += pprint.pformat(replay.sc2readerData.raw_data)

    return HttpResponse(everything.replace("\n", "<br>"))

def analyzeReplayForIdleNess(request,replayhash=""):
    import replayparsing
    import replayanalyzer

    if len('cd2061ff6d809f719f9d4c410a3ffa1c') == len(replayhash):
        for ch in replayhash:
            if not ch.isalnum():
                return HttpResponse("wait ... what?" + replayhash)
    else:
        return HttpResponse("wait ... what?" + replayhash)

    analyzer = IdleProductionAnalyzer((os.path.join(settings.REPLAY_UPLOAD_FOLDER, replayhash + '.SC2Replay')))

    data = []

    ID=0

    for player in analyzer.productionLog:
        print str(player)
        for building in analyzer.productionLog[player].active:
            print building
            ID+=1 
            title = analyzer.replay.getPlayerName(player) + "\\\'s " + building + " activity"
            subtitle = "Pipelines active"

            active = []
            available = []

            for frame in range(0,max(analyzer.productionLog[player].active[building].keys()),16):
                active.append(analyzer.productionLog[player].active[building][frame])

            for frame in range(0,max(analyzer.productionLog[player].active[building].keys()),16):
                available.append(analyzer.productionLog[player].available[building][frame])

            inProduction = analyzer.productionLog[player].inProduction

            data.append(
                {'ID': ID,
                 'subtitle': subtitle,
                'title': title,
                'inProduction': inProduction,
                'data': [{'name': 'Available', 'data': available},
                          {'name': 'Pipelines active', 'data': active}]})

        for building in analyzer.productionLog[player].available:
            print "Available: " + building


    content = render_to_string('idle_analysis.html', {'graphs': data}, context_instance = RequestContext(request))

    return HttpResponse(content)


def test():
    data = []
    data.append(
        {'ID': 1,
            'subtitle': 'Barracks',

                     'data': [{'name': 'available', 'data': [1,2,3,4,5]},
                              {'name': 'used', 'data': [0,0,3,3,3]}]
        })
    data.append(
        {'ID': 2,
            'subtitle': 'Starport',
                     'data': [{'name': 'available', 'data': [1,2,3,4,5]},
                              {'name': 'used', 'data': [0,0,3,3,3]}]
        })
    data.append(
        {'ID': 3,
            'subtitle': 'Rofl',
                     'data': [{'name': 'available', 'data': [1,2,3,4,5]},
                              {'name': 'used', 'data': [0,0,3,3,3]}]
        })



    content = render_to_string('idle_analysis.html', {'graphs': data}, context_instance = RequestContext(request))

    return HttpResponse(content)

def analyzeReplay(request,replayhash=123):
    import replayparsing
    import replayanalyzer
    if len('cd2061ff6d809f719f9d4c410a3ffa1c') == len(replayhash):
        for ch in replayhash:
            if not ch.isalnum():
                return HttpResponse("wait ... what?" + replayhash)
    else:
        return HttpResponse("wait ... what?" + replayhash)

    analysis = replayanalyzer.ReplayAnalyzer((os.path.join(settings.REPLAY_UPLOAD_FOLDER, str(request.user.id), replayhash + '.SC2Replay')))

    from .forms import UploadReplayForm

    form = UploadReplayForm()

    stats = defaultdict(dict)

    deathStats = analysis.worker_death_stats

    for player in deathStats:
        deathStatsString = ""
        deathStatsString += analysis.replay.getPlayerName(player) + ":\n"
        workers = 0
        for element in deathStats[player]:
            if element in ['SCV', 'Drone', 'Probe']:
                workers+=deathStats[player][element]

            deathStatsString += element 
            deathStatsString += " x " 
            deathStatsString += str(deathStats[player][element]) 
            deathStatsString += "\n"
        deathStatsString += "Total workers killed: " + str(workers) + "\n\n"
        stats[str(player)]['DEATH_STATS'] = deathStatsString

    lostStats = analysis.lost
    for player in lostStats:
        lostString = ""
        lostString += analysis.replay.getPlayerName(player) + ":\n"
        workers = 0
        for element in lostStats[player]:
            if element in ['SCV', 'Drone', 'Probe']:
                workers+=lostStats[player][element]

            lostString += element 
            lostString += " x " 
            lostString += str(lostStats[player][element]) 
            lostString += "\n"
        lostString += "Total workers lost: " + str(workers) + "\n\n"
        stats[str(player)]['LOST_STATS'] = lostString

    cancelledStats = analysis.cancelled

    for player in cancelledStats:
        cancelledString = ""
        cancelledString += analysis.replay.getPlayerName(player) + ":\n"
        workers = 0
        for element in cancelledStats[player]:
            if element in ['SCV', 'Drone', 'Probe']:
                workers+=cancelledStats[player][element]

            cancelledString += element 
            cancelledString += " x " 
            cancelledString += str(cancelledStats[player][element]) 
            cancelledString += "\n"
        cancelledString += "Total workers cancelled: " + str(workers) + "\n\n"
        stats[str(player)]['CANCELLED_STATS'] = cancelledString

    createdStats = analysis.created

    for player in createdStats:
        createdString = ""
        createdString += analysis.replay.getPlayerName(player) + ":\n"
        workers = 0
        for element in createdStats[player]:
            if element in ['SCV', 'Drone', 'Probe']:
                workers+=createdStats[player][element]

            createdString += element 
            createdString += " x " 
            createdString += str(createdStats[player][element]) 
            createdString += "\n"
        createdString += "Total workers created: " + str(workers) + "\n\n"
        stats[str(player)]['CREATED_STATS'] = createdString

    content = render_to_string('graphs.html', { 'playerstats': dict(stats), 'DATA': analysis.report, 'form': form, 'replayhash': replayhash }, context_instance = RequestContext(request))

    return HttpResponse(content)
    
def uploadReplay(request):
    from django.http import HttpResponseRedirect
    from django.template import RequestContext

    from django.shortcuts import render_to_response
    from .forms import UploadReplayForm

    from utilities.ReplayUploader import ReplayUploader
    from utilities.ReplayCruncher import ReplayCruncher

    if request.method == 'POST':
        form = UploadReplayForm(request.POST, request.FILES)
        if form.is_valid():
            result = ReplayUploader().handle_uploaded_file_for_user(request,request.FILES['replayFile'])
            if result[0]:
                if request.user.is_authenticated():
                    ReplayCruncher().crunch_replay(request.user, result[1])

                return HttpResponseRedirect('/analyze_replay/' + result[1].hash + '/')
            else:
                return HttpResponse('Something went wrong ...')
    else:
        form = UploadReplayForm()
    
    return render_to_response("upload.html", {'form': form, }, context_instance = RequestContext(request))

from django.core.servers.basehttp import FileWrapper


def downloadReplay(request, user, replayhash):
    print "User",user
    print replayhash
    if len('cd2061ff6d809f719f9d4c410a3ffa1c') == len(replayhash):
        for ch in replayhash:
            if not ch.isalnum():
                return HttpResponse("Go away!")
    else:
        return HttpResponse("Go away.")

    if not user.isdigit():
        return HttpResponse("Go away please.")

    from django.utils.encoding import smart_str

    file_name = replayhash + '.SC2Replay'
    response = HttpResponse(FileWrapper(open(os.path.join(settings.REPLAY_UPLOAD_FOLDER, user, file_name)), content_type='application/octet-stream', mimetype='application/force-download'))
    response['Content-Disposition'] = 'attachment; filename=%s' % smart_str(file_name)
    response['X-Sendfile'] = smart_str(file_name)

    # It's usually a good idea to set the 'Content-Length' header too.
    # You can also set any other required headers: Cache-Control, etc.
    return response
