from django.conf.urls import patterns, include, url

from django.contrib import admin
admin.autodiscover()

from buildpractice import views

urlpatterns = patterns('',
    url(r'new', views.createNewPracticeSession, name='Create new practice session'),
    url(r'add_elements/(.*)/$', views.addElementsToSession, name='Add elements to practice session'),
    url(r'publish/([^/]+)/$', views.sharePracticeSession, name='Publish practice session'),
    url(r'start/(\d+)/$', views.startPracticeSession, name='Start practice session'),
    url(r'builds/(\d+)/$', views.publicBenchmarks, name='Public benchmarks'),
    url(r'find/$', views.listPublicBenchmarks, name='List public benchmarks'),
    url(r'edit/(.*)/$', views.addElementsToSession, name='Edit practice session'),
    url(r'delete/([^/]+)/$', views.deletePracticeSession, name='Delete practice session'),
    url(r'upload_replays/(.*)/$', views.uploadReplaysToSession, name='Add elements to practice session'),
    url(r'upload_replays/(.*)', views.uploadReplaysToSession, name='Add elements to practice session'),
    url(r'deleteElement/([^/]+)/(\d+)/', views.deleteElementFromSession, name='Delete element from practice session'),
    url(r'deleteUpgradeElement/([^/]+)/(\d+)/', views.deleteUpgradeElementFromSession, name='Delete upgrade element from practice session'),
    url(r'deleteBuildingElement/([^/]+)/(\d+)/', views.deleteBuildingFromSession, name='Delete building from practice session'),

)
