from collections import defaultdict

from replayparsing import *
from replayfolder import *

os.environ['DJANGO_SETTINGS_MODULE'] = 'replay.settings'

from utilities.WorkerCounter import *
from utilities.WinsAgainstLeagueCounter import *

from stats.models import WorkersCreated

from account.models import BattleNetAccount

#collection = ReplayCollection("/home/replays/uploaded",limit=1)

from pprint import pprint


folder = ReplayFolder("/home/replays/uploaded/")

winstats = defaultdict(int)

for replayFile in folder.replayFiles:
    try:
        replay = Replay(replayFile)
        if not replay.valid:
            continue

        for player in replay.players:
            if replay.getGameType() != '1v1':
                continue

            print replayFile    
        
            if replay.getPlayerName(player) == 'flyrev':
                league_win_counter = WinsAgainstLeagueCounter().stats(replay,player)
                for C in league_win_counter:
                    winstats[C] += league_win_counter[C]
                    print winstats
                    break
    except KeyError:
        continue

print winstats

import sys
sys.exit()













# replay = Replay('/home/replays/uploaded/61092b97a0b6d77b267beedc8e5ffbc3.SC2Replay') # random 3v3
replay = Replay('/home/replays/uploaded/924e59bc9c57c06c4c8c520d2eaf4499.SC2Replay') # arranged 3v3

pprint (vars(replay.sc2readerData))

print replay.sc2readerData

for player in replay.players:
    print replay.getPlayerName(player),replay.getLeague(player)
    league_win_counter = WinsAgainstLeagueCounter().stats(replay,player)
    print league_win_counter

print ";;;"

workerCounter = defaultdict(int)
for replay in collection.replays:
    counter = WorkerCounter().worker_stats(replay)

    for bnet_uid in counter:
        workerCounter[bnet_uid] += counter[bnet_uid]

for bnet_uid in workerCounter:
    bnetAccount, created = BattleNetAccount.objects.get_or_create(bnet_id=bnet_uid)
    
    workersCreated, created = WorkersCreated.objects.get_or_create(bnet_id=bnetAccount)
    if created:
        workersCreated.bnet_name = 'Unknown'
    workersCreated.workers_created = workersCreated.workers_created+workerCounter[bnet_uid]
    workersCreated.save()
    
    
