from django.db import models

from analysis.models import Replay

class ReplayInInbox(models.Model):
	user = models.ForeignKey('auth.User')
	replay = models.ForeignKey(Replay)

	def __str__(self):
		return str(self.replay)

class ReplayAnalysisElement(models.Model):
	replay = models.ForeignKey(ReplayInInbox)
	time = models.CharField(max_length = 10)
	note = models.CharField(max_length = 1024)

	def __str__(self):
		try:
			return str(self.replay) + " " + str(self.time) + " " + str(self.note)
		except UnicodeEncodeError:
			return "Unicode error"
