from django.shortcuts import render

from django.http import HttpResponse
from django.http import HttpResponseRedirect


from django.template import RequestContext
from django.template.loader import render_to_string
from django.shortcuts import render_to_response

from utilities.ReplayUploader import ReplayUploader
from utilities.ReplayCruncher import ReplayCruncher

from models import *
from forms import *

from analysis.models import Replay as ReplayModel

from django.shortcuts import redirect

from utilities.Cruncher import *

from replayparsing import Replay

def uploadReplaysToInbox(request):
	results = []

	names = "Files:"
	for replayFile in request.FILES.getlist('replays'):
		names += str(replayFile.name) + " - "

		if request.method == 'POST':
			result = ReplayUploader().handle_uploaded_file_for_user(request,replayFile)
			results.append(result)
			if result[0] == True:
				replayInDb,c = ReplayModel.objects.get_or_create(user=request.user,originalReplayName=replayFile.name, hashValue=result[1].hash)
				replayInInbox,c = ReplayInInbox.objects.get_or_create(user=request.user,replay=replayInDb)
				if c:
					WorkerStatsCruncher(result[1], request.user).crunch()
					ReplayCruncher().crunch_replay(request.user, result[1])

					
				
	return redirect("/account/")

def viewInbox(request):
	inbox = []
	analyzed_count=0
	for rep in ReplayInInbox.objects.filter(user=request.user).all():
		elements = []
		analyzed = False
		for element in ReplayAnalysisElement.objects.filter(replay=rep).all():
			elements.append(element)
			analyzed = True
		if analyzed:
			analyzed_count+=1
			
		inbox.append({'replay': rep, 'elements': elements})

	inbox.reverse()
	content = render_to_string('inbox.html', {'replays': inbox, 'analyzed': analyzed_count, 'total_replays': len(inbox), 'medal': 'bronze'}, context_instance = RequestContext(request))

	return HttpResponse(content)

def findReplayInInbox(user,hashValue):
	for replay in ReplayInInbox.objects.filter(user=user).all():
		print "Going through",replay,"hv=",hashValue
		if replay.replay.hashValue==hashValue:
			return replay

	return None

import operator

def analyzeReplay(request,hashValue):
	rep = findReplayInInbox(request.user,hashValue)

	elements = []

	for element in ReplayAnalysisElement.objects.filter(replay=rep).all():
		elements.append(element)

	elements.sort(key=lambda x: int(x.time.split(":")[0])*60 + int(x.time.split(":")[1]))

	USER_ID = request.user.id

	content = render_to_string('manual_analysis.html', {'REPLAY_HASH': hashValue, 'USER_ID': USER_ID, 'elements': elements, 'REPLAY_NAME': rep.replay.originalReplayName, 'form': MistakeElementForm()}, context_instance = RequestContext(request))

	return HttpResponse(content)

def add_analysis_element(request,hashValue):
	rep = findReplayInInbox(request.user,hashValue)

	if 'time' in request.POST and 'mistake' in request.POST:
		element = ReplayAnalysisElement(replay=rep, time=request.POST['time'], note=request.POST['mistake'])
		element.save()

	return analyzeReplay(request,hashValue)
