from django.db import models

# Create your models here.
class Result(models.Model):
    from account.models import BattleNetAccount
    bnet_id = models.ForeignKey(BattleNetAccount)
    gametype = models.CharField(max_length = 4)
    team_league = models.CharField(max_length = 20)
    league = models.CharField(max_length = 20)
    winloss = models.BooleanField()

class WorkersCreated(models.Model):
    from account.models import BattleNetAccount
    bnet_id = models.ForeignKey(BattleNetAccount)
    workers_created = models.IntegerField(default=0)

class WorkersKilled(models.Model):
    from account.models import BattleNetAccount
    bnet_id = models.ForeignKey(BattleNetAccount)
    workers_killed = models.IntegerField(default=0)

class WinsAgainstLeague(models.Model):
    from account.models import ArrangedTeam
    team = models.ForeignKey(ArrangedTeam)
    unknown_league_wins = models.IntegerField(default=0)
    bronze_wins = models.IntegerField(default=0)
    silver_wins = models.IntegerField(default=0)
    gold_wins = models.IntegerField(default=0)
    platinum_wins = models.IntegerField(default=0)
    diamond_wins = models.IntegerField(default=0)
    master_wins = models.IntegerField(default=0)
    grandmaster_wins = models.IntegerField(default=0)
