from replayparsing import Replay

from django.core.exceptions import MultipleObjectsReturned, ObjectDoesNotExist

from account.models import *

class ReplayCruncher:
    def __init__(self):
        pass

    def crunch_replay(self,websiteUser,replay):
        from django.db.models import Count

        winningTeam = replay.getWinningTeam()
        team = replay.getTeams()[replay.getWinningTeam()]
        
        from collections import defaultdict
        loser_leagues = defaultdict(int)
        for player in replay.players:
            if not replay.players[player]['is_winner']:
                print "Loser",replay.getPlayerName(player),"in",replay.getLeague(player)
                loser_leagues[replay.getLeague(player)] += 1

        print loser_leagues

        bnet_accounts_team = []
        for member in team:
            try:
                obj, c = BattleNetTeamAccount.objects.get_or_create(team_user=websiteUser, bnet_name=member['name'], bnet_id=member['uid'])
            except MultipleObjectsReturned:
                obj = BattleNetTeamAccount.objects.filter(team_user=websiteUser, bnet_name=member['name'], bnet_id=member['uid']).latest('pk')
                c = False
            bnet_accounts_team.append(obj)

        arrangedteams = ArrangedTeam.objects.annotate(c=Count('members')).filter(c=len(team))

        for member in bnet_accounts_team:
            arrangedteams = arrangedteams.filter(members=member)

        from stats.models import WinsAgainstLeague

        print "AT='",str(arrangedteams),"'"
        if len(arrangedteams.all()) == 0:
            print "No teams"
        else:
            for T in arrangedteams:
                print "Found arranged team to match",T
                win_record, c = WinsAgainstLeague.objects.get_or_create(team=T)
                print win_record,c
                
                win_record.unknown_league_wins += loser_leagues["No league"]

                win_record.bronze_wins += loser_leagues["Bronze"]
                win_record.silver_wins += loser_leagues["Silver"]
                win_record.gold_wins += loser_leagues["Gold"]
                win_record.platinum_wins += loser_leagues["Platinum"]
                win_record.diamond_wins += loser_leagues["Diamond"]
                win_record.master_wins += loser_leagues["Master"]
                win_record.grandmaster_wins += loser_leagues["Grandmsater"]

                
                win_record.save()
        

