from django.conf import settings

class ReplayUploader:
    def __init__(self):
        pass

    def handle_uploaded_file_for_user(self,request,tmpReplayFile):
        import tempfile
        f = tempfile.NamedTemporaryFile(delete=False)
        for chunk in tmpReplayFile.chunks():
            f.write(chunk)
        f.close()

        from replayparsing import Replay
        import shutil
        import os
    
        replay = Replay(f.name)

        if replay.valid:
            directory = os.path.join(settings.REPLAY_UPLOAD_FOLDER, str(request.user.id))
            print "Trying to upload into",directory

            if not os.path.exists(directory):
                os.makedirs(directory)

            destination = os.path.join(directory, replay.hash + ".SC2Replay")

            if not os.path.exists(destination):
                shutil.copyfile(f.name, destination)
            else:
                print f.name,"already existed at",destination

            os.unlink(f.name)
            return (True,replay)
        else:
            print f.name,"not a valid replay"
            os.unlink(f.name)
            return (False,None)
