# The first element is what something is called in the replay.
# The second element is the human-readable form.

class UnitList:
	def __init__(self):
		self.gatewayunits = ['Zealot', 'Stalker', 'Sentry', 'HighTemplar', 'DarkTemplar']
		
		self.units = {}
		self.units['Terran'] = [('SCV','SCV'),
		                     ('Marine','Marine'),
		                     ('Marauder','Marauder'),
		                     ('Reaper','Reaper'),
		                     ('Banshee','Banshee'),
		                     ('VikingFighter','Viking'),
		                     ('WidowMine','Widow Mine'),
		                     ('Medivac','Medivac'),
				     ('Hellion', 'Hellion'),
		                     ('HellionTank','Hellbat'), 
		                     ('SiegeTank','Siege Tank'),
				     ('Thor', 'Thor'),
		                     ('Raven','Raven'),
		                     ('Battlecruiser','Battlecruiser'),
		                     ('Nuke','Nuclear missile'),

		                    ]
		                    
		self.units['Zerg'] = [('Drone','Drone'),
							  ('Zergling','Zergling'),
							  ('Baneling','Baneling'),	
							  ('Queen','Queen'),
							  ('Roach','Roach'),
							  ('Hydralisk','Hydralisk'),
							  ('Infestor', 'Infestor'),
							  ('SwarmHostMP', 'Swarm host'),
							  ('Mutalisk','Mutalisk'),
							  ('Corruptor','Corruptor'),
							  ('Ultralisk','Ultralisk'),
							  ('Overlord','Overlord'),
							  ('Overseer','Overseer'),
							  ('BroodLord','Brood lord'),
							  ('Viper','Viper')
							  ]
		self.units['Protoss'] = [('Probe','Probe'),
								('Zealot','Zealot'),
								('Stalker','Stalker'),
								('Sentry','Sentry'),
								('MothershipCore', 'Mothership Core'),
								('Mothership','Mothership'),
								('Phoenix','Phoenix'),
								('Carrier','Carrier'),
								('DarkTemplar','Dark Templar'),
								('HighTemplar', 'High Templar'),
								('Archon', 'Archon'),
								('WarpPrism', 'Warp Prism'),
								('Observer','Observer'),
								('Immortal','Immortal'),
								('VoidRay', 'Void Ray'),
								('Oracle', 'Oracle'),
								('Colossus', 'Colossus')
								]

		self.upgrades = {}
		self.upgrades['Terran'] = [('Stimpack','Stimpack'),
								   ('ShieldWall', 'Combat shield'),
								   ('PunisherGrenades','Concussive shells'),
								   ('TerranInfantryWeaponsLevel1', 'Infantry attack level 1'),
								   ('TerranInfantryWeaponsLevel2', 'Infantry attack level 2'),
								   ('TerranInfantryWeaponsLevel3', 'Infantry attack level 3'),
								   ('TerranInfantryArmorsLevel1', 'Infantry armor level 1'),
								   ('TerranInfantryArmorsLevel2', 'Infantry armor level 2'),
								   ('TerranInfantryArmorsLevel3', 'Infantry armor level 3'),
								   ('TerranVehicleAndShipWeaponsLevel1','Vehicle and ship attack level 1'),
								   ('TerranVehicleAndShipWeaponsLevel2','Vehicle and ship attack level 2'),
								   ('TerranVehicleAndShipWeaponsLevel3','Vehicle and ship attack level 3'),
								   ('TerranVehicleAndShipArmorsLevel1', 'Vehicle and ship armor level 1'),
								   ('TerranVehicleAndShipArmorsLevel2', 'Vehicle and ship armor level 2'),
								   ('TerranVehicleAndShipArmorsLevel3', 'Vehicle and ship armor level 3'),
							   	   ('HighCapacityBarrels', "Blue flame"),
								   ('MedivacCaduceusReactor', "Medivac starting energy"),
					                           ('BansheeCloak', "Banshee cloak"),
								   ('RavenCorvidReactor', "Raven starting energy"),
								   ('PersonalCloaking', "Ghost cloak"),
								   ('DrillClaws',"Widow mine burrow speed"),
								   ('BattlecruiserEnableSpecializations',"Yamato gun"),
							   	   ('BattlecruiserBehemothReactor',"Battlecruiser starting energy"),
								   ('TerranBuildingArmor','Building armor'),
							   	   ('HiSecAutoTracking', "Range for turrets and PFs"),
							   	   ('NeosteelFrame', 'Bunker upgrade'),
								   ]

		self.upgrades['Protoss'] = [('WarpGateResearch', 'Warp gate research'),
									('BlinkTech','Blink'),
									('Charge', 'Charge'),
									('ExtendedThermalLance', 'Colossus range'),

									('ProtossGroundWeaponsLevel1', "Ground weapons level 1"),
									('ProtossGroundWeaponsLevel2', "Ground weapons level 2"),
									('ProtossGroundWeaponsLevel3', "Ground weapons level 3"),
									('ProtossGroundArmorsLevel1', 'Ground armors level 1'),
									('ProtossGroundArmorsLevel2', 'Ground armors level 2'),
									('ProtossGroundArmorsLevel3', 'Ground armors level 3'),
									
									('ProtossAirWeaponsLevel1', 'Air weapons level 1'),
									('ProtossAirWeaponsLevel2', 'Air weapons level 2'),
									('ProtossAirWeaponsLevel3', 'Air weapons level 3'),
									('ProtossAirArmorsLevel1', 'Air armor level 1'),
									('ProtossAirArmorsLevel2', 'Air armor level 2'),
									('ProtossAirArmorsLevel3', 'Air armor level 3'),
									('CarrierLaunchSpeedUpgrade', 'Carrier launch speed'),

									('PhoenixRangeUpgrade', 'Phoenix range'),

									('PsiStormTech', 'Psi storm'),
									('ObserverGraviticBooster', "Observer speed"),
									('GraviticDrive', 'Warp prism speed'),



									('ProtossShieldsLevel1', 'Shields level 1'),
									('ProtossShieldsLevel2', 'Shields level 2'),
									('ProtossShieldsLevel3', 'Shields level 3')
									]
		self.upgrades['Zerg'] = [('zerglingmovementspeed', 'Zergling speed'),
								('CentrificalHooks','Baneling speed'),
								('GlialReconstitution', 'Roach speed'),
								('ZergMeleeWeaponsLevel1', 'Melee attack level 1'),
								('ZergMeleeWeaponsLevel2', 'Melee attack level 2'),
								('ZergMeleeWeaponsLevel3', 'Melee attack level 3'),
								('ZergGroundArmorsLevel1', 'Groun armor level 1'),
								('ZergGroundArmorsLevel2', 'Ground armor level 2'),
								('ZergGroundArmorsLevel3', 'Ground armor level 3'),
								('ZergMissileWeaponsLevel1', 'Ranged attack level 1'),
								('ZergMissileWeaponsLevel2', 'Ranged attack level 2'),
								('ZergMissileWeaponsLevel3', 'Ranged attack level 3'),
								('ZergFlyerWeaponsLevel1', 'Air weapons level 1'),
  								('ZergFlyerWeaponsLevel2', 'Air weapons level 2'),
								('ZergFlyerWeaponsLevel3', 'Air weapons level 3'),
								('ZergFlyerArmorsLevel1', 'Air armor level 1'),
								('ZergFlyerArmorsLevel2', 'Air armor level 2'),
								('ZergFlyerArmorsLevel3', 'Air armor level 3'),
								('NeuralParasite', 'Neural parasite'),
								('Burrow','Burrow'),
								('zerglingattackspeed', 'Zergling attack speed'),
								('overlordtransport', 'Overlord transport'),
					                        ('overlordspeed', 'Overlord speed'),
								('ChitinousPlating', 'Ultralisk armor'),
								('LocustLifetimeIncrease', 'Locust lifetime increase'),
								('InfestorEnergyUpgrade', 'Infestor starting energy'),
								('HydraliskSpeedUpgrade', 'Hydralisk speed'),
								('hydraliskspeed', 'Hydralisk range') # yes, this is correct.
								]
		self.buildings = {}

		self.buildings['Terran'] = [('Barracks','Barracks'),
			    ('Factory', 'Factory'),
			    ('Starport','Starport'),
			    ('CommandCenter', 'Command Center'),
			    ('GhostAcademy', 'Ghost Academy'),
			    ('FusionCore', 'Fusion Core'),
			    ('EngineeringBay', 'Engineering Bay'),
			    ('Armory', 'Armory'),
			    ]

		self.buildings['Zerg'] = [('Hatchery','Hatchery'),
			    ('SpawningPool', 'Spawning Pool'),
			    ('RoachWarren', 'Roach Warren'),
			    ('HydraliskDen', 'Hydralisk Den'),
			    ('InfestationPit', 'Infestation Pit'),
			    ('EvolutionChamber','Evolution Chamber'),
			    ('BanelingNest', 'Baneling nest'),
			    ('Spire', 'Spire'),
			    ('UltraliskCavern', 'Ultralisk Cavern')
			   ]

		self.buildings['Protoss'] = [('Nexus','Nexus'),
			     ('Gateway', 'Gateway'),
			     ('CyberneticsCore', 'Cybernetics Core'),
			     ('Stargate', 'Stargate'),
			     ('RoboticsFacility','Robotics Facility'),
			     ('RoboticsBay', 'Robotics Bay'),
			     ('FleetBeacon', 'Fleet Beacon'),
			     ('TemplarArchive', 'Templar Archives'),
			     ('DarkShrine', 'Dark Shrine'),
			     ('Forge', 'Forge')
			     ]

	def getHumanName(self,thing):
		for race in ['Zerg','Protoss','Terran']:
			for unit in self.units[race]:
				if unit[0] == thing:
					return unit[1]

			for upgrade in self.upgrades[race]:
				if upgrade[0] == thing:
					return upgrade[1]

			for building in self.buildings[race]:
				if building[0] == thing:
					return building[1]

		return thing
